\chapter{Formal Constructs}\label{using-predicates}

{\LARGE F}ormalism is the last thing that stays in a software developers mind nowadays. 
This is a result of mismanaging expectation of how software and coding is taught and practiced in industry.
The majority view in the Industry is :
\begin{center}
\emph{Software is a form of art, and is not science at all}. 
\end{center}
It is easy to showcase that this is the prevailing feeling. When the last time people
actually did any mathematics to reach any conclusion like - what would be the optimal
object hierarchy size if any? What should be the optimal pool size for an application?
How one can optimally transform the data? 

Most of these cases, a bit of formal thinking solves a lot of the problems that can come due to bad design,
if there was a design in the first place (for most parts, there are none). 
That is, because software is nothing but formally applied computer science, and industry lacks computer science.
What can be done by 100 can also be done by 10 people, and no, they do not have to be really really smart,
they only have to be understanding the underlying structure. 
In reality software is :

\begin{center}
\emph{Software is to Applied Computation is what Architecture is to applied sciences, i.e. Engineering.}
\end{center}
Unless you have an idea of the underlying mechanism, most won't work,
and those who would luckily work - would simply fail in a slightly longer timeframe.
Moreover, user does not care about brilliant design and optimal code, user care about getting his/her problem 
solved, fast. It is business who should care about how to do things optimally and repeatedly, otherwise,
the business model won't sustain. 

This section would be specifically to understand what sort of formalism from computation 
we can use in practice to develop and test software to aid business. Because in the end, profit and revenue 
runs the show.

\begin{section}{Conditional Building Blocks}

\begin{subsection}{Formalism}
\index{Predicate Logic}
In a formal logic like \href{https://en.wikipedia.org/wiki/First-order\_logic}{FOPL}, 
the statements can be made from the basic ingredients, 
\emph{``there exist''} and \emph{``for all''}. We need to of course put some logical stuff like $AND$, $OR$,
and some arithmetic here and there, but that is what it is.

If we have noted down the \emph{sorting problem} in chapter 2, we would have restated the problem as :

\begin{center}
\emph{ There does not exist an element which is less than that of the previous one. }
\end{center} 

In mathematical logic, \emph{``there exists''} becomes : $\exists$ and \emph{``for all''} becomes $\forall$.
and logical not is shown as $\neg$ ,  So, the same formulation goes in : let 
$$
S = \{ 0, 1, 2, ... , size(a)-1  \} =  \{  x \in \mathbb{N} | x < size(a) \} 
$$
then :
$$
  i \in S ; \forall \; i  \neg \; ( \exists \; a[i] \; s.t. \; a[i] < a[i-1]    ) 
$$ 

And the precise formulation of what is a sorted array/list is done in the 
\href{https://en.wikipedia.org/wiki/Second-order_logic}{second order logic}.
The problem of programming and validation generally is expressive in terms of 
\href{https://en.wikipedia.org/wiki/Higher-order_logic}{higher order logic}.
\index{logic : 2nd order}\index{logic : higher order}
\end{subsection}
\begin{subsection}{Relation between ``there exists'' and ``for all'' }
\index{relation between exists and forall}
There is a nice dual relationship between there exists $\exists$ and $\forall$.
Given we have the negation operation defined, $\forall$ and $\exists$  are interchangeable.
Suppose we ask :  
\begin{center}
\emph{ Are every element in the collection C greater than 0? }
$$
\forall x \in C \; ; \; x > 0 \; ?
$$
\end{center}
This can be reformulated as the negation of:
\begin{center}
\emph{ Does there exist any element in the collection C less than or equal to 0? }
$$
\exists x \in C \; ; \; x \le 0 \; ?
$$
\end{center}
Hence, the transformation law is :

$$
\forall x \in C \; ; \; P(x) \; ? \Longleftrightarrow \neg ( \exists x \in C \; ; \; \neg P(x) \; ) ?
$$
\end{subsection}

\begin{subsection}{There Exist In Containers}
\index{Predicate Logic : there exists}
To check, if some element is, in some sense exists inside a container ( list, set, dict, array, heap )
one needs to use the $IN$ operator, which is $@$. \index{operator : at }
\index{ operator : division over dictionary }
\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
l = [1,2,3,4] // l is an array 
in = 1 @ l // in is true 
in = 10 @ l // in is false 
d = { 'a' : 10 , 'b' : 20  }
in = 'a' @ d // in is true 
in = 'c' @ d // in is false 
in = 10 @ d // in is false 
in = 10 @ d.values() // in is true 
/* division over a dictionary gives the keyset 
where the value of the key is the operand */
in = size( d / 10 ) > 0  // in is true 
s = "hello"
in = "o" @ s // in is true 
/* This works for linear collections even */
m = [2,3]
in = m @ l // true 
in = l @ l // true  
// the not in operator is defined as such 
10 !@ l // true : not in 
1 !@ l // false : not in
\end{lstlisting}
\end{minipage}\end{center}

This was not simply put in the place simply because we simply dislike $x.contains(y)$. 
In fact we do dislike the form of object orientation where there is no guarantee that $x$ would be null or not.
Worse, it is impossible to test for \emph{null} always, such is the prevailing nature of the bad code in Industry. 
Formally, then :

\begin{lstlisting}[style=zmbStyle]
// equivalent function 
def in_function(x,y){ (x != null) && x.contains(y) }
// or one can use simply 
y @ x // same result
\end{lstlisting}

What about positions? \emph{startsWith}  and \emph{endsWith} or even \emph{containsAsSubList} ?
All these 3 are essentially pattern matching, with various anchor points for collections

\begin{lstlisting}[style=zmbStyle]
l = [1,2,3,4]
l #^ 1 // l indeed starts with 1 
l #^ [1,2]  // l indeed starts with [1,2 ]  
l #^ [] // vacously true 
l #$ 4 // l indeed ends with 4 
l #$ [3,4]  // l indeed ends with [3,4 ]  
l #$ [] // vacously true 
[2,3 ] #@ l // true, indeed [2,3] exists inside l as a sub list 
[1,4 ] #@ l // false, indeed [1,4]  does not exist inside l as a sub list 
\end{lstlisting}
  
This can be extended to patterns where a collection matches full the iteration order of another 
collection:

\begin{lstlisting}[style=zmbStyle]
l = [1,2,3,4]
m = [1,2,3,4]
k = [2,3,4,1]
l == k // true : Collection equality is  match in any order 
k #= m // false
l #= m // true  
\end{lstlisting}
  


How about pure regular expressions? There are two operators related to regular expressions,
the \emph{match} operator, and then \emph{not match} operator. \index{regular expressions}
See the \href{http://www.regular-expressions.info/quickstart.html}{guide to regular expressions}.
\index{ operator : regex : match }
\index{ operator : regex : not match }

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
re = "^[-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?$"
s = "hello"
match = ( s =~ re ) // false 
match = ( s !~ re ) // true 
f = "12.3456"
match = ( f =~ re ) // true 
match = ( f !~ re ) // false 
\end{lstlisting}
\end{minipage}\end{center}

Thus, the operator ``=\textasciitilde'' is the \emph{match} operator, while  ``!\textasciitilde'' is the \emph{not match} operator.
\index{ operator : \textasciitilde }

Regex can be specified verbatim:
\begin{lstlisting}[style=zmbStyle]
me = 'cool!'
me =~ ##^c.*$# // true 
me =~ ##c.*# // false
me =~ ##co#g // global match, true
me =~ ##Co#ig // ignore case, global match, true
\end{lstlisting}

The right side of the operator, the \# operand returns a pattern.
It is obvious that the `g' is for global, `i' is for ignore case.
`m' is used for being multiline.

Moreover, to substitute pattern, that is replace with a variable, start with a question mark.
 
\begin{lstlisting}[style=zmbStyle]
me = 'cool!'
p = 'Co'
me =~ ##p#ig // false, p is verbatim 
me =~ ##? p#ig // true, p is executed as script first, then substituted
\end{lstlisting}

In the same spirit - List sub sequences can be tested for match:

\begin{lstlisting}[style=zmbStyle]
l = [1,2,3,4]
l =~ [1,3] // true 
l =~ [2] // true 
l =~ [2,10] // false
l =~ [] // true, vacously  
\end{lstlisting}

So in this sense there is a symmetry around the \emph{IN} class of operators.

\end{subsection}

\begin{subsection}{Size of Containers : empty, size, cardinality}
To check whether a container is empty or not, 
use the $empty()$ \index{empty()} function, just mentioned above. Hence:
\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
n = null
e = empty(n) // true 
n = []
e = empty(n) // true 
n = list()
e = empty(n) // true 
d = { : }
e = empty(d) // true 
nn = [ null ]
e = empty(nn) // false 
\end{lstlisting}
\end{minipage}\end{center}

For the actual size of it, there are two alternatives.
One is the $size()$ \index{size()}  function :

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
n = null
e = size(n) // -1 
n = []
e = size(n) // 0 
n = list()
e = size(n) // 0 
d = { : }
e = size(d) // 0 
nn = [ null ]
e = size(nn) // 1 
\end{lstlisting}
\end{minipage}\end{center}

Observe that it returns negative given input null. 
That is a very nice way of checking null.
The other one is the $cardinal$ operator \index{operator : cardinality }:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
n = null
e = #|n| // 0 
n = []
e = #|n| // 0 
n = list()
e = #|n| // 0 
d = { : }
e = #|d| // 0 
nn = [ null ]
e = #|nn| // 1 
\end{lstlisting}
\end{minipage}\end{center}

This operator in some sense gives a \href{https://en.wikipedia.org/wiki/Measure\_(mathematics)}{measure}. It can not be negative, 
so cardinality of $null$ is also 0. 
\end{subsection}

\begin{subsection}{There Exist element with Condition : index, rindex , exists }
Given we have if \emph{``y in container x''} or not,
what if when asked a question like : \emph{ ``is there a x in Collection C such that predicate P(x) is true''} ?
Formally, then, given a predicate $P(x)$, and a collection $C$, we ask :
$$
\exists x \in C \;s.t.\; P(x) = True
$$

This pose a delicate problem. 

Notice this is the same problem we asked about sorting. Is there an element `x' in $C$, 
such that the sorting order is violated? If not, the collection is sorted.
This brings back the $index$ function \index{index()}.
We are already familiar with the usage of $index()$ function from chapter 2.
But we would showcase some usage :
\index{Predicate Logic : there exist : index() }
 
\begin{lstlisting}[style=zmbStyle]
l = [ 1, 2, 3, 4, 5, 6 ]
// search an element such that double of it is 6
i = index(l) where { $.o * 2 == 6 } // i : 2 
// search an element such that it is between 3 and 5 
i = index(l) where { $.o < 5 && $.o > 3 } // i : 3 
// search an element such that it is greater than 42
i = index(l) where {  $.o > 42 }// i : -1, failed 
\end{lstlisting}

The way index function operates is: the statements inside the anonymous block are executed.
If the result of the execution is true, the index function returns the index in the collection.
If for none of the elements the anonymous block assumes the true value, it returns a failure by returning $-1$.

NOTE that in the ZoomBA negative indices are proper indices into a collection.
Thus, a code like this is tantamount to be a disaster waiting to happen:
 
\begin{lstlisting}[style=zmbStyle]
l = [ 1, 2, 3, 4, 5, 6 ]
// search an element   
i = index(l) where { $.o > 42 } // i : -1
// now we have found the element, so :
x = l[i] // no, x is 6. we must check the index value for >=0
\end{lstlisting}

This brings to the problem of actually finding the element, which is solved using \emph{find()} function.
\index{Predicate Logic : Find : find() }

\begin{lstlisting}[style=zmbStyle]
l = [ 1, 2, 3, 4, 5, 6 ]
// search an element   
mc = find(l) where { $.o > 3 } // result is MonadicContainer
// now we have found the element, so :
r = mc.nil ? mc.value : null // r is 4  
\end{lstlisting}

Index function runs from left to right, and there is a variation \emph{rindex()} \index{index()}
which runs from right to left.

\index{Predicate Logic : there exist : rindex() }

\begin{lstlisting}[style=zmbStyle]
l = [ 1, 2, 3, 4, 5, 6 ]
// search an element such that it is greater than 3  
i = index(l) :: { $.o > 3 } // i : 3, :: is the where clause 
// search an element such that it is greater than 3  
i = rindex(l) :: { $.o > 3 } // i : 5 
// search an element such that it is greater than 42
i = rindex(l) :: {  $.o > 42 } // i : -1, failed 
\end{lstlisting}

Thus, the \emph{there exists} formalism is taken care by these operators and functions together.

\index{Predicate Logic : there exist : exists() }
The function $exists()$ to ensure simpler usage on collections where index is kind of meaningless.

\begin{lstlisting}[style=zmbStyle]
l = [ 1, 2, 3, 4, 5, 6 ]
// search an element such that it is greater than 3  
// reads there exists item in collection where clause 
exists(l) where { $.o > 3 } // true 
\end{lstlisting}


\end{subsection}


\begin{subsection}{For All elements with Condition : select }
\index{Predicate Logic : for all : select() }

We need to solve the problem of \emph{for all}. This is done by $select()$ function \index{select()}.
The way select function works is : executes the anonymous statement block, and if the condition is true, 
then select and collect that particular element, and returns a list of collected elements.

\begin{lstlisting}[style=zmbStyle]
l = [ 1, 2, 3, 4, 5, 6 ]
// select all even elements 
evens = select(l) where { $.o % 2 == 0 }
// for math folks
evens = select(l) :: { 2 /? $.o } // reads : where 2 divides the number 
// select all odd elements 
odds = select (l) :: { $.o % 2 == 1 } 
\end{lstlisting}

\end{subsection}

\begin{subsection}{Partition a collection on Condition : partition }
Given a $select()$, we are effectively partitioning the collection into two halves,
$select()$ selects the matching partition. In case we want both the partitions, then 
we can use the $partition()$ function \index{partition()}.

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
l = [ 1, 2, 3, 4, 5, 6 ]
#(evens,odds) = partition(l) :: { $.o % 2 == 0 }
println(evens) // prints 2, 4, 6 
println(odds) // prints 1, 3, 5
\end{lstlisting}\end{minipage}
\end{center}

\end{subsection}

\begin{subsection}{Collecting value on Condition : select, from, concur }
\index{select, from, concur}

Given a $select()$ or $partition()$, we are collecting the values already 
in the collection. What about we want to change the values we are collecting,
or what about the container we want to collect into? 

These scenarios can be translated into:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
collector = collection()
def condition(item){/* some predicate */}
def map(item){/* some mapping */}
// now the loop 
for ( item : collection ){
   if ( condition(item) ){
     collector.add( map(item ) )
   }
} 
// use collector 
\end{lstlisting}\end{minipage}
\end{center}

Or, one can use the standard:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
l = [ 1, 2, 3, 4, 5, 6 ]
evens = select(l) where { $.o % 2 == 0 } as { $.o ** 2 }
println(evens) // prints 4, 16, 36 
\end{lstlisting}\end{minipage}
\end{center}

$where{}$ is the condition function, while $as{}$ is the mapper function.
You can pass the collector collection also:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
select([0:5],set()) where { 2 /? $.o }
\end{lstlisting}\end{minipage}
\end{center}
this, of course will collect the items in a set. While $select()$ only supports two levels of composition, 
one predicate and one mapper, \emph{from()} supports full functional composition:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
from([0:11],set()) where { 3 /? $.o } as {  $.o % 3 }
\end{lstlisting}\end{minipage}
\end{center}

A concurrent ( multi-threaded ) form of \emph{from} is available as \emph{concur}:


\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
concur([0:11],set()) where { 3 /? $.o } as {  $.o % 3 }
\end{lstlisting}\end{minipage}
\end{center}

As one can see there is no visible difference, only in the name. It works almost exactly like 
\emph{from} but does the mapping in a multi-threaded way. 
One has to be careful to avoid \emph{break} statement in the function - it has no meaning in an un co-ordinated 
non deterministic system.



\end{subsection}

\begin{subsection}{ As vs Where }
By now, it is pretty clear that the anonymous functions take two forms. \emph{where} and \emph{as} - one is
used to hint conditional ( predicate ) aspect of things, and another mapper aspect of things.
\emph{where} should be strictly used when we are looking at decision making. 
\emph{as} should be strictly used when we are looking at mapping functions. 

In \emph{sort[ad]()} functions,  the implementation differs internally based on 
what sort of anonymous function is being used. Observe a student object as follows.
If we want to sort the list of student generated by a field, there is no point writing a custom 
comparator - we can very well give a mapping function that scalarifies the object into an auto comparable:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
def Student : { role : 42 , name : "HHGG"  }
students = list ( [0:5 ) ) as { 
   new ( Student , role : random(1000), name : random( "\S+", 32 ) ) 
  }
// now sort by role ?
sorta( students ) as { $.o.role }
// now sort by name ?
sorta( students ) as { $.o.name }
\end{lstlisting}\end{minipage}
\end{center}

This is 1-1 with how a select query would chose to scalarify a tuple for ordering in \emph{Order By} clause.

\end{subsection}


\begin{subsection}{Inversion of Logic}
As we have discussed there is a relation between $\exists$ and $\forall$, 
we can use them for practical applications. We would be using them everywhere, 
and as \href{http://psychology.about.com/od/psychologyquotes/a/lewinquotes.htm}{Kurt Lewin} said :
\begin{center}
\emph{There is nothing so practical as a good theory.}
\end{center}
So, we would start with all these examples in inverted logic.
Observe that $select()$ mandates a guaranteed \href{https://en.wikipedia.org/wiki/Big_O_notation}{runtime} of $\Theta(n)$,
while $index()$ has a probabilistic runtime of $\Theta(n/2)$. So, we should generally choose $index()$ over $select()$.
For example, take the problem of \emph{are all numbers in a list larger than 0}, it can be solve in two ways:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
l = [10,2,3,10, 2, 0 , 9 ]
// forall method 1
size(l) == size ( select(l) :: { $.o > 0 } )    
// forall method 2 : note the inversion of logic 
empty ( select(l) :: { $.o <= 0 } )    
// there exists method : note the inversion of condition from 1
 !exists(l) :: { $.o <= 0 }
\end{lstlisting}\end{minipage}
\end{center}

Please choose the 3rd one, that makes sense, takes less memory, and is optimal.    
\end{subsection}

\end{section}

\begin{section}{Operators from Set Algebra}

\begin{subsection}{Set Algebra}
\index{Set Algebra}

\href{https://en.wikipedia.org/wiki/Algebra_of_sets}{Set algebra}
, in essence runs with the notions of the following ideas :
\begin{enumerate}
\item{There is an unique empty set.}
\item { The following operations are defined :
\begin{enumerate}{
     \item{Set Union is defined as : \index{Set Algebra : Union}
$$
U_{AB} = A \cup B \; :=  \{ x \in A \; or \; x \in B \} := U_{BA}
$$ 
}
    \item{Set Intersection is defined as : \index{Set Algebra : Intersection}
$$
I_{AB} = A \cap B \; :=  \{ x \in A \; and \; x \in B \} := I_{BA}
$$
}
\item{Set Minus is defined as : \index{Set Algebra : Minus}
$$
M_{AB} := A \setminus B \; :=  \{ x \in A \; and \; x \not \in B \} 
$$
thus, $M_{AB} \ne M_{BA}$. 
}
\item{Set Symmetric Difference is defined as : \index{Set Algebra : Symmetric Difference} 
$$
\Delta_{AB} := ( A \setminus B ) \cup ( B  \setminus A ) := \Delta_{BA}
$$
}
\item{Set Cross Product is defined as : 
$$
X_{AB} = \{ ( a, b ) \; | \; a \in A \; and \;  b \in B  \} 
$$
thus, $X_{AB} \ne X_{BA}$
}
}
\end{enumerate}}
\item{ The following relations are defined:
\begin{enumerate}

\item{ Subset Equals : \index{Set Algebra : Subset Equals}
$$
A \subseteq B \; when \;  x \in A \implies x \in B
$$
}

\item{ Equals : \index{Set Algebra : Equals}
$$
A = B \; when \; A \subseteq B \; and \; B \subseteq A
$$
}


\item{ Proper Subset : \index{Set Algebra : Subset,Proper}
$$
A \subset B \; when \; A \subseteq B \; and \; \exists x \in B \;s.t.\; x \not \in A
$$
}

\item{ Superset Equals: \index{Set Algebra : Superset Equals}
$$
A \supseteq B \; when \; B \subseteq A 
$$
}

\item{ Superset : \index{Set Algebra : Superset,Proper}
$$
A \supset B \; when \; B \subset A 
$$
}
\end{enumerate}}
\end{enumerate}
\end{subsection}

\begin{subsection}{Set Operations on Collections}
\index{Set Operations : Collection}

For the sets, the operations are trivial. 
The only interesting departure from regular mathematical operator
 is ``$\backslash$'' which is the operator for \emph{collection (set) minus}. 
 This is because operators like ``$+,-$'' are used to do element operations onto collections.
 
\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
s1 = set(1,2,3,4)
s2 = set(3,4,5,6)
u = s1 | s2 // union is or : u = { 1,2,3,4,5,6}
i = s1 & s2 // intersection is and : i = { 3,4 }
m12 = s1 \ s2 // m12 ={1,2}
m21 = s2 \ s1 // m12 ={5,6}
delta = s1 ^ s2 // delta = { 1,2,5,6}
\end{lstlisting}
\end{minipage}\end{center}


For the lists or arrays, where there can be multiple elements present, 
this means a newer formal operation.
Suppose in both the lists, an element `e' is present, in $n$ and $m$ times.
So, when we calculate the following :
\begin{enumerate}
\item{Intersection :
  the count of $e$ would be $min(n,m)$.
}
\item{Union :
  the count of $e$ would be $max(n,m)$.
}
\item{Minus :
  the count of $e$ would be $max(0,n-m)$.
}

\end{enumerate}
With this, we go on for lists:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
l1 = list(1,2,3,3,4,4)
l2 = list(3,4,5,6)
u = l1 | l2 // union is or : u = { 1,2,3,3,4,4,5,6}
i = l1 & l2 // intersection is and : i = { 3,4 }
m12 = l1 \ l2 // m12 ={1,2,3,4}
m21 = l2 \ l1 // m12 ={5,6}
delta = l1 ^ l2 // delta = { 1,2,3,4,5,6}
\end{lstlisting}
\end{minipage}\end{center}

Now, for dictionaries, the definition is same as lists, 
because there the dictionary can be treated as a list of key-value pairs.
So, for one pair to be equal to another, both the key and the value must match.
Thus:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
d1 = {'a' : 10, 'b' : 20 , 'c' : 30 }
d2 = {'c' : 20 , 'd' : 40  }
// union is or : u = { 'a' : 10, 'b' : 20, 'c' : [ 30,20] , 'd' : 40  }
u = d1 | d2 
i = d1 & d2 // intersection is and : i = { : } 
m12 = d1 - d2 // m12 = d1 
m12 = d1 \ d2 // m12 = d1 
m21 = d2 - d1 // m12 = d2
m21 = d2 \ d1 // m12 = d2
delta = d1 ^ d2 // delta = {'a' : 10, 'b' : 20,  'c' : [30,20] , 'd': 40}
\end{lstlisting}
For dictionaries the ``$\backslash$'' is same as ``$-$''.  
Notice the symmetric difference in case the value of the key does not match.
In that case the result is an ordered pair of  \emph{ (left,right) values}.

\end{minipage}\end{center}



\end{subsection}

\begin{subsection}{Collection Cross Product and Power}
The cross product, as defined, with the multiply operator:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
l1 = [1,2,3]
l2 = ['a','b' ]
cp = l1 * l2 
/* [[1, a], [1, b], [2, a], [2, b], [3, a], [3, b]] := cp */
\end{lstlisting}
\end{minipage}\end{center}

Obviously we can think of power operation or exponentiation 
on a collection itself. That would be easy (we use `$:=$` to say \emph{defined as} ) :

$$
A^0 := \{\} \; , \; A^1 := A \; , \; A^2 := A \times A
$$
and thus :
$$
A^n :=  A^{n-1} \times A
$$

Collection power in general can not be negative.
Here are some examples now:

\begin{lstlisting}[style=zmbStyle]
b = [0,1]
gate_2 = b*b // [ [0,0],[0,1],[1,0],[1,1] ]
another_gate_2 = b ** 2 // same as b*b 
gate_3 = b ** 3 // well, all truth values for 3 input gate 
gate_4 = b ** 4 // all truth values for 4 input gate 
b ** 0 // [] : power zero is empty collection
\end{lstlisting}

String is also a collection, and all of these are applicable for string too.
But it is a special collection, so only power operation is allowed.

\begin{lstlisting}[style=zmbStyle]
s = "Hello"
s2 = s**2 // "HelloHello"
s_1 = s**-1 // "olleH"
s_2 = s**-2 // "olleHolleH"
\end{lstlisting}

One interesting case is that of negative power.
A negative power is a valid power for an \emph{ordered collection} 
like an \emph{array} or a \emph{list},
negation implies a reversal of order in such a collection, 
if such thing is possible : \index{collections : reverse}

\begin{lstlisting}[style=zmbStyle]
b = [0,1]
rb = b** -1 // [1 , 0 ]
s = "hello" 
rs = s**-1 // "olleh" 
rb = b** -2 // [[1, 0], [1, 1], [0, 0], [0, 1]]
s = "hello" 
rs = s**-2 // "olleholleh"
// sorted list 
sl = slist(3,1,2 ) // 1,2,3 
sl ** -1 // 3,1,2 
// ordered set 
os = oset(1,2,3)
os ** -1 // {3,2,1}
// sorted set 
ss = sset(1,3,2)
ss ** -1 // {3,2,1}  
\end{lstlisting}

these are simply not there for curious  purposes.
In the examples section we will see how they ease out some interesting algorithms.
A very practical use case of power operator for string
is padding by zeros for a binary integer of a fixed size:

\begin{lstlisting}[style=zmbStyle]
n = 23
bn = str(n,2) // convert into binary string
padded_8 = "0" ** (8 - #|bn| ) + bn // 00010111 : convert to 8 bit 
padded_8 = str(n,2,8)  // 00010111 : convert to 8 bit 
\end{lstlisting}

\end{subsection}

\begin{subsection}{Collection Relation Comparisons}
\index{Set Relations : Collection}

The operators are defined as such:
\begin{enumerate}
\item{ $A \subset B $ is defined as $A < B $  }
\item{ $A \subseteq B $ is defined as $A <= B $  }
\item{ $A \supset B $ is defined as $A > B $  }
\item{ $A \supseteq B $ is defined as $A >= B $  }
\item{ $A = B$ is defined as $A == B$  }
\end{enumerate}

Note that when collections can not be compared at all, 
it would return false to showcase that the relation fails.

So, we go again with sets:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
s1 = set(1,2,3)
s2 = set(1,3)
sub = s2 < s1 // true  
sup = s1 > s2 // true 
sube = ( s2 <= s1 ) // true  
supe = (s1 >= s2) // true 
s3 = set(5,6)
s1 < s3 // false 
s3 > s1 // false 
s1 != s3 // true
\end{lstlisting}
\end{minipage}\end{center}

So, we go again with lists:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
l1 = list(1,2,3,3,4)
l2 = list(1,3,2)
sub = l2 < l1 // true  
sup = l1 > l2 // true 
sube = ( l2 <= l1 ) // true  
supe = (l1 >= l2) // true 
l3 = list(5,6)
l1 < l3 // false 
l3 > l1 // false 
l1 != l3 // true
\end{lstlisting}
\end{minipage}\end{center}


And finally with dictionaries:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
d1 = {'a' : 10, 'b' : 20 , 'c' : 30 }
d2 = {'c' : 30 , 'a' : 10  }
sub = ( d2 < d1) // true 
sup = ( d1 > d2) // true
\end{lstlisting}
\end{minipage}\end{center}

\end{subsection}


\begin{subsection}{Mixing Collections}
One can choose to intermingle $set$ with $list$, that promotes the $set$ to $list$.
Thus :

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
s = set(1,2,3)
l = list(1,3,3,2)
sub = s < l  // true  
sup = l > s // true 
s == l // false : promotes both to list and checks
u = l | s // u = [1,2,3,3 ]
\end{lstlisting}
\end{minipage}\end{center}

\end{subsection}


\begin{subsection}{Collections as Tuples}
\index{Set Operations : there exist : Collections}

When we say $[1,2] < [1,2,3,4] $ we obviously mean as collection itself.
But what about we start thinking as \href{https://en.wikipedia.org/wiki/Tuple}{tuples}?
Does a tuple contains in another tuple? That is we can find the items in order? 
"@" operator solves that too :

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
l = [1,2]
m = [ [1,2],3,4]
in = l @ m // true 
\end{lstlisting}
\end{minipage}\end{center}

The $index()$, and $rindex()$ generates the index of where the match occurred:

\begin{lstlisting}[style=zmbStyle]
l = [1,2]
m = [1,2,3,4,1,2]
// read which : index is l in m?
forward = index( l , m) // 0 
backward = rindex( l , m) // 4   
\end{lstlisting}

Sometimes it is of importance to get the notion of $starts\_with$ and $ends\_with$.
There are two special operators :
\index{Tuple Operation : Starts With, Ends With}

\begin{lstlisting}[style=zmbStyle]
// read m starts_with l 
sw = m #^ l // true 
// read m ends with l 
ew = m #$ l // true 
\end{lstlisting}

Note that this is also true for strings, as they are collections of characters.
So, these are legal:

\begin{lstlisting}[style=zmbStyle]
s = 'abracadabra'
prefix = 'abra'
suffix = prefix
i = index ( prefix, s ) // 0 
r = rindex( suffix, s ) // 7 
sw = s #^ prefix // true 
ew = s #$ suffix // true 
\end{lstlisting}

These are not fancy stuffs. These are necessary to move over from the stupidity that is known 
as \emph{null based programming} where lots of efforts gets nullified by the stupidity of null.
Observe, the same null thing:

\begin{lstlisting}[style=zmbStyle]
s = 'abracadabra'
prefix = 'abra'
null #^ s // false 
prefix #^ null // false 
[null,null] #^ null // true 
\end{lstlisting}

and thus, we can see where it does the value add.
Python fails in this case, because none of it's syntaxes permits None type
to be used as collection to yield True/False for \emph{in} or \emph{matches}.  

There is this other operator called \emph{InOrder : \#@ } \index{collections : in order} which
tells whether a sub collection exists in order, as tuple in the larger collection 
when the larger collection is considered as tuple:

\begin{lstlisting}[style=zmbStyle]
l = [0,1,2,3,4]
[1,2] #@ l // true 
[2] #@ l // true 
[2,1] #@ l // false 
\end{lstlisting}
as usual, they are all null ready.    
The \emph{in : @} operator is different from \emph{in order}.

There is another interesting operator $\#=$     \emph{ in order and equals} :

\begin{lstlisting}[style=zmbStyle]
l = [0,1,2,3,4]
m = [0,1,3,2,4]
k = [0,1,2,3,4]
l == m  // true
l #= m  // false 
l #= k   // true 
l #= l   // true 
// sub sequence 
l =~ [1,3] // true 
m =~ [0,2,4] // true 
l =~ [4,1] // false 
\end{lstlisting}
 
 This is how most languages thinks about \emph{equality} in list and arrays.
 In ZoomBA it is called \emph{iteration equals}, or \emph{order equals}. 
 
Thus, in order is precisely what it is, if the items from the passed collection
occurs as sub tuples ( can be build by projection operations ) of the parent collection. 
Formally, let's end this with a bit of formalism as we have started it.

Define a projection operation $\Pi_{i,j}(C) $ with $i \le j $ which slice the collection $C$
from index $i$ to index $j$, or rather a \emph{sub()} function. Let $|X|$ be the cardinality 
or size of the collection $X$.
Then, the following are defined as such :

\begin{enumerate}
\item{
  \textbf{ In Order And Equals:} \\
   $ A \; \#= \; B $ iff    $ |A| = |B| \; ;  \;   \forall i  \; \Pi_{i,i}(A) = \Pi_{i,i}(B) $.  
}


\item{
  \textbf{ In Order :} \\
   $ x \; \#@ \; C $ iff $\exists (i,j)$ such that $\Pi_{i,j}(C) = x $.  
}
\item{
  \textbf{ Starts With :} \\
   $ C \; \# \textasciicircum \; x $ iff $\exists j$ such that $\Pi_{0,j}(C) = x $.  
}
\item{
  \textbf{ Ends With :} \\
   $ C \; \#\$ \; x $ iff $\exists i$ such that $\Pi_{i,|C|-1}(C) = x $.
}
\end{enumerate}
\end{subsection}

\end{section}

\begin{section}{Assertions}
It of utmost important that we do protective coding. What does that mean? That means, for any function, 
verify the inputs, and decides, what needs to be done. For the same purpose, there are some very specific functions
which are in place.

\begin{subsection}{Existence of Variables}
\index{ is() }
There are one specific function which is in place: \emph{is()} . 

\begin{lstlisting}[style=zmbStyle]
is( x )  // false, x does not exist in Context
x = 10 
is( x )  // true, x exists
is( null )  // true, x exists and is null 
del x // removes the variable name 'x'
is(x) // false, x does not exist any more
\end{lstlisting}

A related operator is \emph{??} which is read as :

\begin{lstlisting}[style=zmbStyle]
val = try_expression ?? default_expression
d = { 'a' : 11 }
val = d.y ?? 42 // val is 42 
val = d.a ?? 42 // val is 11 
\end{lstlisting}
\emph{If try\_expression fails or is null, then assign val to default, else val is try expression}.

\end{subsection}

\begin{subsection}{Verifying Truth about Expressions}
\index{assert(), panic(), test() }
Sometimes, most of the time, we need to check if some expression is true or false. 
Most of the time, that might lead you do to throw exceptions or errors. ZoomBA handles it in a neat way.

There are 3 in built constructs one can try upon \emph{assert(), panic(), test()}.
Here are examples of the same:

\begin{lstlisting}[style=zmbStyle]
x = 42
// expression true, so error will not be thrown
assert( x == 42, 'Why x is not 42?' )
// expression false, so error will not be thrown 
panic( x != 42, 'Why x is not 42?' ) 
// expression false, so error will BE thrown
assert( x != 42, 'Why x is not 42?' ) 
// expression true, so error will BE thrown
panic( x == 42, 'Why x is not 42?' ) 
// true, so nothing will happen
test(x == 42, 'I am good' )  
// false, so would log it to standard error
test(x != 42, 'I am not good' )  
\end{lstlisting}
All of these functions are arbitrary valued arguments, with one mandatory argument, the expression 
which evaluates to true, false. Rest all are processed in, and passed to the runtime, if the assertion fails. 
Thus, all passed extra arguments can be used by runtime, thereby extending the functionality if it is intended to be.

There are guard blocks around each of them. One example is :

\index{ guard block }
\begin{lstlisting}[style=zmbStyle]
assert( '"x" does not exist' ) where { x }
\end{lstlisting}

What is the difference from the original form? If we use the basic expression form, then,
we do get a variable error that 'x' does not exist. Which is entirely a different problem.
The where clause is called a guard block, there, expression can be safely executed, to produce true,false.
Obviously, for assert() and test() the clause must return false to fire error, and for panic() it is to be true. 

\end{subsection}


\end{section}



